// скетч курятника для брата на RTC и 1637

#define       pin_SW_SDA    3                           // Назначение любого вывода Arduino для работы в качестве линии SDA программной шины I2C.
#define       pin_SW_SCL    4                           // Назначение любого вывода Arduino для работы в качестве линии SCL программной шины I2C.
#define       tm_CLK        5                           // для тм1637   
#define       tm_DIO        6                           //            
#define       en_CLK        7                           // энкодер
#define       en_DT         8                           // энкодер            
#define       en_SW         9                           // энкодер
#define       hr_ON         6                           // час включения по умолчанию
#define       mm_ON         0                           // минуты включения по умолчанию
#define       hr_OFF        21                          // час выключения по умолчанию
#define       mm_OFF        0                           // минуты выключения по умолчанию
#define       rl            13                          // выход на реле
#define       rl_on         0                           // активный уровень реле
#define       rl_of         1                           // пассивный уровень реле


int           hh;                                       // часы текущие
int           mm;                                       // минуты текущие
int           hhm;                                      // часы включения утренние
int           mmm;                                      // минуты включения утренние
int           hhe;                                      // часы выключения вечерние
int           mme;                                      // минуты выключения вечерние
int           p_lgt =        400;                       // уровень срабатывания датчика  analogRead(A0);
int           e_hon =        1;                         // ячейка ЕЕПРОМ для часов включения
int           e_mon =        2;                         // ячейка ЕЕПРОМ для минут включения
int           e_hoff =       3;                         // ячейка ЕЕПРОМ для часов выключения
int           e_moff =       4;                         // ячейка ЕЕПРОМ для минут выключения
byte          b_pnt =        0;                         // для отображения точки при работающих часах
byte          b_nast =       0;                         // для цикла настройки
byte          b_nast1 =      0;                         // для выхода из функции encod
byte          swl =          0;                         // признак работы света (0- отключен, 1- включен)
int           t_sw =         100;                       // дельта для предотвращения переключения

// подключаем библиотЭки
#include      <GyverEncoder.h>
#include      "GyverTM1637.h"
#include      <EEPROM.h>
#include      <Wire.h>

Encoder enc1(en_CLK, en_DT, en_SW);
GyverTM1637   disp(tm_CLK, tm_DIO);
#include      <iarduino_RTC.h>                          // Подключаем библиотеку iarduino_RTC для работы с модулями реального времени.
iarduino_RTC watch(RTC_DS1307);

void setup()
{
  enc1.setType(TYPE2);                                    // тип энкодера TYPE1 одношаговый, TYPE2 двухшаговый. Если ваш энкодер работает странно, смените тип
  delay(300);                                             // Ждем готовности модуля отвечать на запросы.
  // Serial.begin(9600);                                     // Инициируем передачу данных в монитор последовательного порта на скорости 9600 бод.
  watch.begin();                                          // Инициируем работу с модулем.
  disp.brightness(4);
  pinMode(rl, OUTPUT);                                    // выход на реле

  // проверка ЕЕПРОМ на наличие данных и присваивание времени включения/отключения

  if (EEPROM.read(e_hon) == 255 && EEPROM.read(e_hoff) == 255) // проверка по часам включения/ отключения (если 255- новая)
  {
    EEPROM.write(e_hon, hr_ON);                           // записываем в ЕЕПРОМ часы/ минуты включения/ отключения
    EEPROM.write(e_mon, mm_ON);
    EEPROM.write(e_hoff, hr_OFF);
    EEPROM.write(e_moff, mm_OFF);
  }

  hhm = EEPROM.read(e_hon);                               // считываем из ЕЕПРОМ часы/ минуты включения/ отключения
  mmm = EEPROM.read(e_mon);
  hhe = EEPROM.read(e_hoff);
  mme = EEPROM.read(e_moff);
}

void loop()
{
  enc1.tick();                                              // Опрашиваем энкодер
  if (enc1.isClick())                                       // если был нажат энкодер
  { //НАСТРОЙКА
#include      "timeNastr.h"
  }

  if (b_nast == 0)
  {
    // РАБОТА
    if (millis() % 1000 == 0)                               // Если прошла 1 секунда.
    {
      hh = atoi (watch.gettime("H"));                       // Получаем часы
      mm = atoi (watch.gettime("i"));                       // Получаем минуты

      if (b_pnt == 1)
      {
        disp.point(1);                                      // вкл точки
        b_pnt = 0;
      }
      else
      {
        disp.point(0);                                      // выкл точки
        b_pnt = 1;
      }
      disp.displayClock(hh, mm);                            // выводим время
      delay(1);                                             // Приостанавливаем скетч на 1 мс
      
    }
  }

  // срабатывание по датчику освещения
  if (hh < hhm)                                             // если не достигли даже часа включения
  {
    swl = 0;
  }

  if (hh == hhm && mm >= mmm)                               // достигли времени включения
  {

    swl = 1;                                                // указываем что свет зажегся
  }

  if (hh > hhm && hh <= hhe)                                // работа между установленными часами
  {
    swl = 1;                                                // указываем что свет зажегся
  }

  if ( hh == hhe && mm >= mme)                              // достигли времени отключения
  {
    swl = 0;                                                // указываем что свет погашен
  }

  if ( hh > hhe )                                           // выше заданного часа отключаем
  {
    swl = 0;                                                // указываем что свет погашен
  }


  if ((analogRead(A0) < p_lgt) && swl == 1)               // зажигаем освещение при недостаточной яркости на улице и гасим при достаточной
  {
    if ((analogRead(A0)<p_lgt-t_sw)) digitalWrite (rl, rl_on);
  }
  else
  {
    digitalWrite (rl, rl_of);
  }
}

// функция настройки VALUE- значение, maxim- максимальное значение, hm- регулировка часов при 1, иначе- минуты, h- часы, m- минуты
int encod(int value, int maxim, int hm, int h, int m)
{
  b_nast1++;
  while (b_nast1 > 0)
  {
    // Serial.println(value);
    enc1.tick();
    if (enc1.isRight()) value++;                          // если был поворот направо, увеличиваем на 1
    if (enc1.isLeft()) value--;                           // если был поворот налево, уменьшаем на 1

    if (value < 0) value = 0;
    if (value > maxim) value = maxim;

    if (hm == 1)
    {
      disp.displayClock(value, m);
    }
    else
    {
      disp.displayClock(h, value);
    }

    if (enc1.isClick())
    {
      b_nast1 = 0;                                        // выход из цикла
      b_nast++;                                           // переходим на следующий пункт меню
      return  value;
    }
  }
}
